/*
 * Copyright (c) 2026 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jetbrains.skia

import org.jetbrains.skia.impl.NativePointer
import org.jetbrains.skia.impl.Stats
import org.jetbrains.skia.impl.getPtr
import org.jetbrains.skia.impl.reachabilityBarrier
import org.jetbrains.skiko.ExternalRenderNode

fun Canvas.drawRenderNode(node: ExternalRenderNode, rect: Rect): Canvas {
    Stats.onNativeCall()
    try {
        _nDrawRenderNode(getPtr(this), node.nativePtr, rect.left, rect.top, rect.right, rect.bottom)
    } finally {
        reachabilityBarrier(this)
    }
    return this
}

@ExternalSymbolName("org_jetbrains_skia_Canvas__1nDrawRenderNode")
private external fun _nDrawRenderNode(ptr: NativePointer, nodePtr: NativePointer, left: Float, top: Float, right: Float, bottom: Float)
